{"filter":false,"title":"FoxHound.js","tooltip":"/source/FoxHound.js","undoManager":{"mark":69,"position":69,"stack":[[{"start":{"row":275,"column":0},"end":{"row":306,"column":0},"action":"insert","lines":["\t\t/**","\t\t* Set the join data element","\t\t*","\t\t* The passed values can be either an object or an array of objects.","\t\t*","\t\t* The join object has four values:","\t\t* {Type:'INNER JOIN', Table:'Test', From:'Test.ID', To:'Scope.IDItem'}","\t\t*","\t\t* @method setJoin","\t\t* @param {Object} pJoin The join criteria(s) for the Query.","\t\t* @return {Object} Returns the current Query for chaining.","\t\t*/","\t\tvar setJoin = function(pJoin)","\t\t{","\t\t\t_Parameters.join = [];","","\t\t\tif (Array.isArray(pJoin))","\t\t\t{","\t\t\t\tpJoin.forEach(function(join)","\t\t\t\t{","\t\t\t\t\taddJoin(join.Table, join.From, join.To, join.Type);","\t\t\t\t});","\t\t\t}","\t\t\telse if (typeof(pJoin) === 'object')","\t\t\t{","\t\t\t\taddJoin(pJoin.Table, pJoin.From, pJoin.To, pJoin.Type);","\t\t\t}","","\t\t\treturn this;","\t\t}","",""],"id":2,"ignore":true},{"start":{"row":518,"column":0},"end":{"row":575,"column":0},"action":"insert","lines":["\t\t/**","\t\t* Add a join expression","\t\t*","\t\t* {Type:'INNER JOIN', Table:'Test', From:'Test.ID', To:'Scope.IDItem'}","\t\t*","\t\t* @method addJoin","\t\t* @return {Object} Returns the current Query for chaining.","\t\t*/","\t\tvar addJoin = function(pTable, pFrom, pTo, pType = 'INNER JOIN')","\t\t{","\t\t\tif (typeof(pTable) !== 'string')","\t\t\t{","\t\t\t\t_Fable.log.warn('Tried to add an invalid query join table', {queryUUID:_UUID, parameters:_Parameters});","\t\t\t\treturn this;","\t\t\t}","\t\t\tif (typeof(pFrom) === 'undefined' || typeof(pTo) === 'undefined')","\t\t\t{","\t\t\t\t_Fable.log.warn('Tried to add an invalid query join field', {queryUUID:_UUID, parameters:_Parameters});","\t\t\t\treturn this;","\t\t\t}","\t\t\t//sanity check the join fields","\t\t\tif (pFrom.indexOf(pTable)!=0)","\t\t\t{","\t\t\t\t_Fable.log.warn('Tried to add an invalid query join field, join must come FROM the join table!', {queryUUID:_UUID, parameters:_Parameters, invalidField:pFrom});","\t\t\t\treturn this;","\t\t\t}","\t\t\tif (pTo.indexOf('.')<=0)","\t\t\t{","\t\t\t\t_Fable.log.warn('Tried to add an invalid query join field, join must go TO a field on another table ([table].[field])!', {queryUUID:_UUID, parameters:_Parameters, invalidField:pTo});","\t\t\t\treturn this;","\t\t\t}","","\t\t\tvar tmpJoin = (","\t\t\t\t{","\t\t\t\t\tType: pType,","\t\t\t\t\tTable: pTable,","\t\t\t\t\tFrom: pFrom,","\t\t\t\t\tTo: pTo","\t\t\t\t});","","\t\t\tif (!Array.isArray(_Parameters.join))","\t\t\t{","\t\t\t\t_Parameters.join = [tmpJoin];","\t\t\t}","\t\t\telse","\t\t\t{","\t\t\t\t_Parameters.join.push(tmpJoin);","\t\t\t}","","\t\t\tif (_LogLevel > 2)","\t\t\t{","\t\t\t\t_Fable.log.info('Added a join', {queryUUID:_UUID, parameters:_Parameters, newFilter:tmpFilter});","\t\t\t}","","\t\t\treturn this;","\t\t};","",""]},{"start":{"row":799,"column":20},"end":{"row":801,"column":20},"action":"insert","lines":["","\t\t\tsetJoin: setJoin,","\t\t\taddJoin, addJoin,"]}],[{"start":{"row":304,"column":3},"end":{"row":304,"column":4},"action":"insert","lines":[";"],"id":3}],[{"start":{"row":569,"column":76},"end":{"row":569,"column":97},"action":"remove","lines":[", newFilter:tmpFilter"],"id":4}],[{"start":{"row":526,"column":50},"end":{"row":526,"column":65},"action":"remove","lines":[" = 'INNER JOIN'"],"id":5}],[{"start":{"row":526,"column":49},"end":{"row":526,"column":50},"action":"remove","lines":["e"],"id":6}],[{"start":{"row":526,"column":49},"end":{"row":526,"column":50},"action":"insert","lines":["e"],"id":7}],[{"start":{"row":548,"column":4},"end":{"row":549,"column":0},"action":"insert","lines":["",""],"id":8},{"start":{"row":549,"column":0},"end":{"row":549,"column":3},"action":"insert","lines":["\t\t\t"]}],[{"start":{"row":549,"column":3},"end":{"row":550,"column":0},"action":"insert","lines":["",""],"id":9},{"start":{"row":550,"column":0},"end":{"row":550,"column":3},"action":"insert","lines":["\t\t\t"]}],[{"start":{"row":550,"column":3},"end":{"row":550,"column":4},"action":"insert","lines":["l"],"id":10}],[{"start":{"row":550,"column":4},"end":{"row":550,"column":5},"action":"insert","lines":["e"],"id":11}],[{"start":{"row":550,"column":5},"end":{"row":550,"column":6},"action":"insert","lines":["t"],"id":12}],[{"start":{"row":550,"column":6},"end":{"row":550,"column":7},"action":"insert","lines":[" "],"id":13}],[{"start":{"row":550,"column":7},"end":{"row":550,"column":8},"action":"insert","lines":["t"],"id":14}],[{"start":{"row":550,"column":8},"end":{"row":550,"column":9},"action":"insert","lines":["m"],"id":15}],[{"start":{"row":550,"column":9},"end":{"row":550,"column":10},"action":"insert","lines":["p"],"id":16}],[{"start":{"row":550,"column":10},"end":{"row":550,"column":11},"action":"insert","lines":["T"],"id":17}],[{"start":{"row":550,"column":11},"end":{"row":550,"column":12},"action":"insert","lines":["y"],"id":18}],[{"start":{"row":550,"column":12},"end":{"row":550,"column":13},"action":"insert","lines":["p"],"id":19}],[{"start":{"row":550,"column":13},"end":{"row":550,"column":14},"action":"insert","lines":["e"],"id":20}],[{"start":{"row":550,"column":14},"end":{"row":550,"column":15},"action":"insert","lines":[" "],"id":21}],[{"start":{"row":550,"column":15},"end":{"row":550,"column":16},"action":"insert","lines":["="],"id":22}],[{"start":{"row":550,"column":16},"end":{"row":550,"column":17},"action":"insert","lines":[" "],"id":23}],[{"start":{"row":550,"column":17},"end":{"row":550,"column":19},"action":"insert","lines":["()"],"id":24}],[{"start":{"row":550,"column":18},"end":{"row":550,"column":19},"action":"insert","lines":["t"],"id":25}],[{"start":{"row":550,"column":19},"end":{"row":550,"column":20},"action":"insert","lines":["y"],"id":26}],[{"start":{"row":550,"column":20},"end":{"row":550,"column":21},"action":"insert","lines":["p"],"id":27}],[{"start":{"row":550,"column":21},"end":{"row":550,"column":22},"action":"insert","lines":["e"],"id":28}],[{"start":{"row":550,"column":22},"end":{"row":550,"column":23},"action":"insert","lines":["o"],"id":29}],[{"start":{"row":550,"column":23},"end":{"row":550,"column":24},"action":"insert","lines":["f"],"id":30}],[{"start":{"row":550,"column":24},"end":{"row":550,"column":26},"action":"insert","lines":["()"],"id":31}],[{"start":{"row":550,"column":25},"end":{"row":550,"column":26},"action":"insert","lines":["p"],"id":32}],[{"start":{"row":550,"column":26},"end":{"row":550,"column":27},"action":"insert","lines":["T"],"id":33}],[{"start":{"row":550,"column":27},"end":{"row":550,"column":28},"action":"insert","lines":["y"],"id":34}],[{"start":{"row":550,"column":28},"end":{"row":550,"column":29},"action":"insert","lines":["p"],"id":35}],[{"start":{"row":550,"column":29},"end":{"row":550,"column":30},"action":"insert","lines":["e"],"id":36}],[{"start":{"row":550,"column":31},"end":{"row":550,"column":32},"action":"insert","lines":[" "],"id":37}],[{"start":{"row":550,"column":32},"end":{"row":550,"column":33},"action":"insert","lines":["="],"id":38}],[{"start":{"row":550,"column":33},"end":{"row":550,"column":34},"action":"insert","lines":["="],"id":39}],[{"start":{"row":550,"column":34},"end":{"row":550,"column":35},"action":"insert","lines":["="],"id":40}],[{"start":{"row":550,"column":35},"end":{"row":550,"column":36},"action":"insert","lines":[" "],"id":41}],[{"start":{"row":550,"column":36},"end":{"row":550,"column":38},"action":"insert","lines":["''"],"id":42}],[{"start":{"row":550,"column":37},"end":{"row":550,"column":38},"action":"insert","lines":["u"],"id":43}],[{"start":{"row":550,"column":38},"end":{"row":550,"column":39},"action":"insert","lines":["n"],"id":44}],[{"start":{"row":550,"column":39},"end":{"row":550,"column":40},"action":"insert","lines":["d"],"id":45}],[{"start":{"row":550,"column":40},"end":{"row":550,"column":41},"action":"insert","lines":["e"],"id":46}],[{"start":{"row":550,"column":41},"end":{"row":550,"column":42},"action":"insert","lines":["i"],"id":47}],[{"start":{"row":550,"column":42},"end":{"row":550,"column":43},"action":"insert","lines":["n"],"id":48}],[{"start":{"row":550,"column":42},"end":{"row":550,"column":43},"action":"remove","lines":["n"],"id":49}],[{"start":{"row":550,"column":41},"end":{"row":550,"column":42},"action":"remove","lines":["i"],"id":50}],[{"start":{"row":550,"column":41},"end":{"row":550,"column":42},"action":"insert","lines":["f"],"id":51}],[{"start":{"row":550,"column":37},"end":{"row":550,"column":42},"action":"remove","lines":["undef"],"id":52},{"start":{"row":550,"column":37},"end":{"row":550,"column":46},"action":"insert","lines":["undefined"]}],[{"start":{"row":550,"column":48},"end":{"row":550,"column":49},"action":"insert","lines":[" "],"id":53}],[{"start":{"row":550,"column":49},"end":{"row":550,"column":50},"action":"insert","lines":["?"],"id":54}],[{"start":{"row":550,"column":50},"end":{"row":550,"column":51},"action":"insert","lines":[" "],"id":55}],[{"start":{"row":550,"column":51},"end":{"row":550,"column":66},"action":"insert","lines":[" = 'INNER JOIN'"],"id":56}],[{"start":{"row":550,"column":52},"end":{"row":550,"column":54},"action":"remove","lines":["= "],"id":57}],[{"start":{"row":550,"column":64},"end":{"row":550,"column":65},"action":"insert","lines":[" "],"id":58}],[{"start":{"row":550,"column":65},"end":{"row":550,"column":66},"action":"insert","lines":[":"],"id":59}],[{"start":{"row":550,"column":66},"end":{"row":550,"column":67},"action":"insert","lines":[" "],"id":60}],[{"start":{"row":550,"column":67},"end":{"row":550,"column":68},"action":"insert","lines":["p"],"id":61}],[{"start":{"row":550,"column":68},"end":{"row":550,"column":69},"action":"insert","lines":["T"],"id":62}],[{"start":{"row":550,"column":69},"end":{"row":550,"column":70},"action":"insert","lines":["y"],"id":63}],[{"start":{"row":550,"column":67},"end":{"row":550,"column":70},"action":"remove","lines":["pTy"],"id":64},{"start":{"row":550,"column":67},"end":{"row":550,"column":72},"action":"insert","lines":["pType"]}],[{"start":{"row":550,"column":72},"end":{"row":550,"column":73},"action":"insert","lines":[";"],"id":65}],[{"start":{"row":554,"column":11},"end":{"row":554,"column":16},"action":"remove","lines":["pType"],"id":66},{"start":{"row":554,"column":11},"end":{"row":554,"column":18},"action":"insert","lines":["tmpType"]}],[{"start":{"row":803,"column":10},"end":{"row":803,"column":11},"action":"remove","lines":[","],"id":67}],[{"start":{"row":803,"column":10},"end":{"row":803,"column":11},"action":"insert","lines":[":"],"id":68}],[{"start":{"row":550,"column":3},"end":{"row":550,"column":6},"action":"remove","lines":["let"],"id":69},{"start":{"row":550,"column":3},"end":{"row":550,"column":4},"action":"insert","lines":["v"]}],[{"start":{"row":550,"column":4},"end":{"row":550,"column":5},"action":"insert","lines":["a"],"id":70}],[{"start":{"row":550,"column":5},"end":{"row":550,"column":6},"action":"insert","lines":["r"],"id":71}]]},"ace":{"folds":[],"scrolltop":8624.5,"scrollleft":0,"selection":{"start":{"row":550,"column":6},"end":{"row":550,"column":6},"isBackwards":false},"options":{"guessTabSize":true,"useWrapMode":false,"wrapToView":true},"firstLineState":0},"timestamp":1534180872622,"hash":"a68abe167634851a39434438a4c723a727671170"}